import java.io.*;
public class MiddleApprox{
    public static void main(String[]args){
        int alen=args.length;
        if(alen==0){
            System.out.println("usage: java MiddleApprox outputfile.txt n m");
            System.out.println("you can change the filename outputname.txt");
            System.out.println("n is the set size as integer number");
            System.out.println("m is the integer length of the set members in bits");
            System.exit(0);
        }
        if(alen!=3){
            System.out.println("error: there must be three arguments");
            System.exit(0);
        }
        int n=0;
        try{
            n=new Integer(args[1]).intValue();
        }
        catch(Exception e1){
            System.out.println("error: second argument must be set size as integer number");
            System.exit(0);
        }
        if(n<=0){
            System.out.println("error: second argument must be set size >0 as integer number");
            System.exit(0);
        }
        int m=0;
        try{
            m=new Integer(args[2]).intValue();
        }
        catch(Exception e2){
            System.out.println("error: third argument must be integer length in bits");
            System.exit(0);
        }
        if(m<=0){
            System.out.println("error: third argument must be integer length >0");
            System.exit(0);
        }
        FileOutputStream fos=null;
        PrintStream ps=null;
        try{
            fos=new FileOutputStream(args[0]);
            ps=new PrintStream(fos);
        }
        catch(Exception e3){
            System.out.println("error creating file "+args[0]);
        }
        try{
            conj(ps,"ANDA","AND","and",n-1);
            conj(ps,"ORA","OR","or",n-1);
            conj(ps,"RESOR","OR","or",n);
            oneadder(ps,m);
            ps.println("MODULE CMP{");
            ps.println("IN ain;");
            ps.println("IN bin;");
            ps.println("IN calculated;");
            ps.println("IN result;");
            ps.println("OUT calculatedo;");
            ps.println("OUT resulto;");
            ps.println("PLA pla 4 2;");
            ps.println("0000 00;");
            ps.println("0001 00;");
            ps.println("0010 10;");
            ps.println("0011 11;");
            ps.println("0100 10;");
            ps.println("0101 10;");
            ps.println("0110 10;");
            ps.println("0111 11;");
            ps.println("1000 11;");
            ps.println("1001 11;");
            ps.println("1010 10;");
            ps.println("1011 11;");
            ps.println("1100 00;");
            ps.println("1101 00;");
            ps.println("1110 10;");
            ps.println("1111 11;");
            ps.println("PLA-END;");
            ps.println("CONNECT ain pla0;");
            ps.println("CONNECT bin pla1;");
            ps.println("CONNECT calculated pla2;");
            ps.println("CONNECT result pla3;");
            ps.println("CONNECT pla0 calculatedo;");
            ps.println("CONNECT pla1 resulto;");
            ps.println("}");
            ps.println("MODULE BITADD{");
            ps.println("IN inb;");
            ps.println("IN in1;");
            ps.println("IN in2;");
            ps.println("OUT out;");
            ps.println("OUT outn;");
            ps.println("PLA pla 3 2;");
            ps.println("000 00;");
            ps.println("001 10;");
            ps.println("010 10;");
            ps.println("011 01;");
            ps.println("100 10;");
            ps.println("101 01;");
            ps.println("110 01;");
            ps.println("111 11;");
            ps.println("PLA-END;");
            ps.println("CONNECT inb pla0;");
            ps.println("CONNECT in1 pla1;");
            ps.println("CONNECT in2 pla2;");
            ps.println("CONNECT pla0 out;");
            ps.println("CONNECT pla1 outn;");
            ps.println("}");
            ps.println("MODULE main{");
            ps.println("CONSTANT c 0;");
            ps.println("CONSTANT d 1;");
            for(int i=0;i<n;i++){
                for(int j=0;j<m;j++){
                    ps.println("CONSTANT c"+i+"x"+j+" 0;");
                }
            }
            ps.println("CMP cmp["+(n*(n-1)*m)+"];");
            for(int i=0;i<n*(n-1);i++){
                ps.println("OR ora"+i+"in1 ora"+i+"in2 ora"+i+"out;");
            }
            for(int i=0;i<n*(n-1);i++){
                ps.println("OR orb"+i+"in1 orb"+i+"in2 orb"+i+"out;");
            }
            for(int i=0;i<n*(n-1);i++){
                ps.println("INV inv"+i+"in inv"+i+"out;");
            }
            ps.println("ANDA and["+n+"];");
            ps.println("ORA or["+n+"];");
            for(int i=0;i<n;i++){
                ps.println("INV invb"+i+"in invb"+i+"out;");
            }
            ps.println("RESOR resor["+m+"];");
            ps.println("RESOR resorb["+m+"];");
            for(int i=0;i<n;i++){
                for(int j=0;j<m;j++){
                    ps.println("AND anda"+i+"x"+j+"in1 anda"+i+"x"+j+"in2 anda"+i+"x"+j+"out;");
                }
            }
            for(int i=0;i<n;i++){
                for(int j=0;j<m;j++){
                    ps.println("AND andb"+i+"x"+j+"in1 andb"+i+"x"+j+"in2 andb"+i+"x"+j+"out;");
                }
            }
            ps.println("ONEADDER"+m+" oneadder;");
            for(int j=0;j<m;j++){
                ps.println("BIT in"+j+" out"+j+" read"+j+" set"+j+" 0;");
            }
            for(int i=0;i<n;i++){
                int jb=0;
                for(int j=0;j<n;j++){
                    if(j!=i){
                        int pos=i*(n-1)+jb;
                        ps.println("CONNECT c"+i+"x0 cmp["+pos+"].ain;");
                        ps.println("CONNECT c"+j+"x0 cmp["+pos+"].bin;");
                        ps.println("CONNECT c cmp["+pos+"].calculated;");
                        ps.println("CONNECT c cmp["+pos+"].result;");
                        jb=jb+1;
                    }
                }
            }
            for(int k=0;k<m-1;k++){
                for(int i=0;i<n;i++){
                    int jb=0;
                    for(int j=0;j<n;j++){
                        if(j!=i){
                            int pos=n*(n-1)*k+i*(n-1)+jb;
                            int posb=n*(n-1)*(k+1)+i*(n-1)+jb;
                            ps.println("CONNECT c"+i+"x"+(k+1)+" cmp["+posb+"].ain;");
                            ps.println("CONNECT c"+j+"x"+(k+1)+" cmp["+posb+"].bin;");
                            ps.println("CONNECT cmp["+pos+"].calculatedo cmp["+posb+"].calculated;");
                            ps.println("CONNECT cmp["+pos+"].resulto cmp["+posb+"].result;");
                            jb=jb+1;
                        }
                    }
                }
            }
            int kb=0;
            for(int i=0;i<n;i++){
                int jb=0;
                for(int j=0;j<n;j++){
                    if(j!=i){
                        int pos=n*(n-1)*(m-1)+i*(n-1)+jb;
                        ps.println("CONNECT cmp["+pos+"].calculatedo ora"+kb+"in1;");
                        ps.println("CONNECT cmp["+pos+"].resulto ora"+kb+"in2;");
                        ps.println("CONNECT ora"+kb+"out inv"+kb+"in;");
                        ps.println("CONNECT cmp["+pos+"].resulto orb"+kb+"in1;");
                        ps.println("CONNECT inv"+kb+"out orb"+kb+"in2;");
                        kb=kb+1;
                        jb=jb+1;
                    }
                }
            }
            kb=0;
            for(int i=0;i<n;i++){
                int jb=0;
                for(int j=0;j<n;j++){
                    if(j!=i){
                        ps.println("CONNECT orb"+kb+"out and["+i+"].in"+(jb+1)+";");
                        kb=kb+1;
                        jb=jb+1;
                    }
                }
            }
            for(int i=0;i<n;i++){
                int jb=0;
                for(int j=0;j<n;j++){
                    if(j!=i){
                        int pos=n*(n-1)*(m-1)+i*(n-1)+jb;
                        ps.println("CONNECT cmp["+pos+"].resulto or["+i+"].in"+(jb+1)+";");
                        jb=jb+1;
                    }
                }
                ps.println("CONNECT or["+i+"].out invb"+i+"in;");
            }
            for(int i=0;i<n;i++){
                for(int j=0;j<m;j++){
                    ps.println("CONNECT c"+i+"x"+j+" anda"+i+"x"+j+"in1;");
                    ps.println("CONNECT and["+i+"].out anda"+i+"x"+j+"in2;");
                    ps.println("CONNECT anda"+i+"x"+j+"out resor["+j+"].in"+(i+1)+";");
                }
            }
            for(int i=0;i<n;i++){
                for(int j=0;j<m;j++){
                    ps.println("CONNECT c"+i+"x"+j+" andb"+i+"x"+j+"in1;");
                    ps.println("CONNECT invb"+i+"out andb"+i+"x"+j+"in2;");
                    ps.println("CONNECT andb"+i+"x"+j+"out resorb["+j+"].in"+(i+1)+";");
                }
            }
            for(int j=0;j<m;j++){
                ps.println("CONNECT resor["+(m-j-1)+"].out oneadder.a"+(j+1)+";");
                ps.println("CONNECT resorb["+(m-j-1)+"].out oneadder.b"+(j+1)+";");
            }
            for(int j=0;j<m;j++){
                ps.println("CONNECT d read"+j+";");
                ps.println("CONNECT d set"+j+";");
            }
            for(int j=0;j<m;j++){
                ps.println("CONNECT oneadder.out"+(j+2)+" in"+(m-j-1)+";");
            }
            ps.println("}");
        }
        catch(Exception e){
            System.out.println("error creating output file");
        }
    }
    public static void oneadder(PrintStream ps,int len){
        try{
            ps.println("MODULE ONEADDER"+len+"{");
            for(int i=1;i<=len;i++){
                ps.println("IN a"+i+";");
                ps.println("IN b"+i+";");
            }
            for(int i=1;i<=len+1;i++){
                ps.println("OUT out"+i+";");
            }
            ps.println("CONSTANT c 0;");
            for(int i=1;i<=len;i++){
                ps.println("BITADD bitadder"+i+";");
            }
            for(int i=1;i<=len;i++){
                ps.println("CONNECT a"+i+" bitadder"+i+".in1;");
                ps.println("CONNECT b"+i+" bitadder"+i+".in2;");
            }
            ps.println("CONNECT c bitadder1.inb;");
            for(int i=1;i<=len-1;i++){
                ps.println("CONNECT bitadder"+i+".outn bitadder"+(i+1)+".inb;");
            }
            for(int i=1;i<=len;i++){
                ps.println("CONNECT bitadder"+i+".out out"+i+";");
            }
            ps.println("CONNECT bitadder"+len+".outn out"+(len+1)+";");
            ps.println("}");
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public static void conj(PrintStream ps,String modulename,String conjtype,String conjname,int conjnum){
        try{
            if(conjnum==0){
                if(conjtype.equals("AND")){
                    ps.println("MODULE "+modulename+"{");
                    ps.println("CYCLE 0;");
                    ps.println("CONSTANT d 1;");
                    ps.println("OUT out;");
                    ps.println("CONNECT d out;");
                    ps.println("}");
                }
                else if(conjtype.equals("OR")){
                    ps.println("MODULE "+modulename+"{");
                    ps.println("CYCLE 0;");
                    ps.println("CONSTANT c 0;");
                    ps.println("OUT out;");
                    ps.println("CONNECT c out;");
                    ps.println("}");
                }
                return;
            }
            ps.println("MODULE "+modulename+"{");
            ps.println("CYCLE 0;");
            for(int i=0;i<conjnum;i++){
                ps.println("IN in"+(i+1)+";");
            }
            ps.println("OUT out;");
            int inputs=conjnum;
            int andscalced=inputs/2;
            int andsinline=inputs/2;
            int firstlinerest=inputs%2;
            if(firstlinerest==1){
                andscalced=andscalced+1;
                if(inputs==1){
                    andscalced=0;
                }
            }
            while(andsinline>1){
                int linerest=andsinline%2;
                andsinline=andsinline/2;
                andscalced=andscalced+andsinline;
                if(linerest==1){
                    andscalced=andscalced+1;
                }
            }
            for(int i=0;i<andscalced;i++){
                ps.println(conjtype+" "+conjname+(i+1)+"in1 "+conjname+(i+1)+"in2 "+conjname+(i+1)+"out;");
            }
            int inputnumber=-1;
            int number=-1;
            int number2=-1;
            int ands1=-1;
            int ands=-1;
            int linebegin=0;
            int nextlinebegin=inputs;
            int restinputs=inputs%2;
            if(restinputs==1){
                inputnumber=inputs;
            }
            if(inputs>1){
                ands1=inputs/2;
                for(int i=0;i<ands1;i++){
                    ps.println("CONNECT in"+(i*2+1)+" "+conjname+(i+1)+"in1;");
                    ps.println("CONNECT in"+(i*2+2)+" "+conjname+(i+1)+"in2;");
                }
                int restands1=ands1%2;
                if(restands1==1){
                    number=linebegin+ands1;
                }
                nextlinebegin=ands1;
                ands=ands1;
                while(ands>1){
                    ands=ands/2;
                    int restands=ands%2;
                    for(int i=0;i<ands;i++){
                        ps.println("CONNECT "+conjname+(linebegin+i*2+1)+"out "+conjname+(nextlinebegin+i+1)+"in1;");
                        ps.println("CONNECT "+conjname+(linebegin+i*2+2)+"out "+conjname+(nextlinebegin+i+1)+"in2;");
                    }
                    linebegin=nextlinebegin;
                    nextlinebegin=nextlinebegin+ands;
                    if(inputnumber>0&&number>0){
                        if(restands==1){
                            number2=nextlinebegin;
                        }
                        nextlinebegin=nextlinebegin+1;
                        ps.println("CONNECT in"+inputnumber+" "+conjname+nextlinebegin+"in1;");
                        ps.println("CONNECT "+conjname+number+"out "+conjname+nextlinebegin+"in2;");
                        number=nextlinebegin;
                        inputnumber=-1;
                    }
                    else if(inputnumber<=0&&number>0&&number2>0){
                        nextlinebegin=nextlinebegin+1;
                        ps.println("CONNECT "+conjname+number+"out "+conjname+nextlinebegin+"in1;");
                        ps.println("CONNECT "+conjname+number2+"out "+conjname+nextlinebegin+"in2;");
                        number=nextlinebegin;
                        number2=-1;
                        inputnumber=-1;
                        if(restands==1){
                            number2=nextlinebegin-1;
                        }
                    }
                    else if(number<=0&&number2<=0){
                        if(restands==1){
                            number=nextlinebegin;
                        }
                    }
                    else if(inputnumber<=0&&number>0&&number2<=0){
                        if(restands==1){
                            number2=nextlinebegin;
                        }
                    }
                }
                int lastnumbers=nextlinebegin;
                if(number==lastnumbers){
                    number=-1;
                    if(number2>0){
                        number=number2;
                        number2=-1;
                    }
                }
                else if(number2==lastnumbers){
                    number2=-1;
                }
                if(inputnumber>0&&number>0){
                    ps.println("CONNECT in"+inputnumber+" "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in2;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+2)+"in1;");
                    ps.println("CONNECT "+conjname+(lastnumbers+1)+"out "+conjname+(lastnumbers+2)+"in2;");
                    lastnumbers=lastnumbers+2;
                }
                else if(number>0&&number2>0){
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+number2+"out "+conjname+(lastnumbers+1)+"in2;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+2)+"in1;");
                    ps.println("CONNECT "+conjname+(lastnumbers+1)+"out "+conjname+(lastnumbers+2)+"in2;");
                    lastnumbers=lastnumbers+2;
                }
                else if(inputnumber>0){
                    ps.println("CONNECT in"+inputnumber+" "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+1)+"in2;");
                    lastnumbers=lastnumbers+1;
                }
                else if(number>0){
                    ps.println("CONNECT "+conjname+number+"out "+conjname+(lastnumbers+1)+"in1;");
                    ps.println("CONNECT "+conjname+lastnumbers+"out "+conjname+(lastnumbers+1)+"in2;");
                    lastnumbers=lastnumbers+1;
                }
                ps.println("CONNECT "+conjname+lastnumbers+"out out;");
            }
            else{
                ps.println("CONNECT in1 out;");
            }
            ps.println("}");
        }
        catch(Exception e){
        }
    }
}
